DCEL theDCEL; 

int to_x(double coordX) {
  return (int)Math.round(coordX);
}

int to_y(double coordY) {
  return (int)Math.round( - coordY);
}

int to_z(double coordZ) {
  return (int)Math.round(coordZ + 100);
}

void setup() {
  size(800, 600, P3D);
  smooth(4);
  background(255);

  ArrayList<Point3d> points = new ArrayList<Point3d>();
  points.add(new Point3d(-200, -150, 0));
  points.add(new Point3d(-100, -150, 0));
  points.add(new Point3d(200, -50, 0));
  points.add(new Point3d(150, 150, 0));
  points.add(new Point3d(-25, 150, 0));
  points.add(new Point3d(-175, -25, 0));
  
  theDCEL = new DCEL(points);
  theDCEL.faces.get(1).offset(20);
  //computeMedialAxis(theDCEL);
}


void draw() {
  background(255);
  translate(width/2,height/2, 0);
  rotateX(5.f * ((height / 2.f) - mouseY) / height);
  rotateY(5.f * (mouseX - (width / 2.f)) / width);
  translate(0,0,-100);
  Random rand = new Random(32);
  
  for (DCEL.Face f : theDCEL.faces) {
    //System.out.println("Face size: " + triangulation.getCycleFrom(f.incidentEdge).size());
    //System.out.println(f == triangulation.outerFace);
    if (f != theDCEL.outerFace) {
      fill(rand.nextInt(256), rand.nextInt(256), rand.nextInt(256));
      ArrayList<DCEL.HalfEdge> edges = theDCEL.getCycleFrom(f.incidentEdge);
      beginShape();
      for (DCEL.HalfEdge he : edges) {
        vertex(to_x(he.origin.coord.x), to_y(he.origin.coord.y), to_z(he.origin.coord.z));
      }
      endShape(CLOSE);
    }
  }
  
  // Draw edges
  stroke(0);
  for (DCEL.HalfEdge e : theDCEL.halfEdges) {
    line(to_x(e.origin.coord.x), to_y(e.origin.coord.y), 
            to_x(e.next.origin.coord.x), to_y(e.next.origin.coord.y));
  }
  
  // Draw vertices
  fill(255);
  stroke(0);
  for (DCEL.Vertex v : theDCEL.vertices) {
    ellipse(to_x(v.coord.x), to_y(v.coord.y), 8, 8);
  }
}