
/**
 * A class for storing 2D Points of doubleegers. 
 */ 
class Point3d {
  
  // The coordinates of the Point
  double x, y, z;
  
  public Point3d(double x, double y, double z) {
    this.x = x;
    this.y = y;
    this.z = z;
  }
  
  /**
   * Computes the square distance from this 
   * Point to that one. Better to use this for comparing
   * distances than to use the actual distance because
   * this avoids the square-root function and rounding errors. 
   * 
   * @param that The Point to compare to. 
   * @return The squared distance from this to that. 
   */
  double distSqTo(Point3d that) {
      double dx = that.x - this.x;
      double dy = that.y - this.y;
      double dz = that.z - this.z;
      return dx*dx + dy*dy + dz*dz;
  }
  
  Point3d plus(Vector3d v) {
    return new Point3d(x + v.x, y + v.y, z + v.z);
  }
  
  Vector3d minus(Point3d that) {
    return new Vector3d(x - that.x, y - that.y, z - that.z);
  }
}